import { world as World, BlockLocation } from "mojang-minecraft"

import { 
	ActionFormData,
	MessageFormData,
	ModalFormData
} from "mojang-minecraft-ui"



World.events.beforeItemUseOn.subscribe(eventData => {
    const { source, blockLocation } = eventData
    const { x, y, z } = blockLocation
    const teste = new BlockLocation(x,y,z)
    if (source.hasTag('is_using_cataclysm')) {
        source.runCommand(`setblock ${teste.x} ${teste.y} ${teste.z} miraculous:cataclysm_block`)
    }
    World.events.tick.subscribe(ticks => {
        if ((ticks.currentTick % 1000) == 0) {
            if (source.hasTag('is_using_cataclysm')) {
                source.removeTag('is_using_cataclysm')
                source.addTag('already_use_cataclysm')
            }
        }
    })
})
World.events.beforeChat.subscribe(evd=>{
    let [sender , message] = [evd.sender , evd.message]
    if (sender.hasTag('is_transformed_bee') && sender.hasTag('is_transformed_ladybug')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§g<§4\"},{\"selector\":\"@s\"},{\"text\":\"§g>§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_cat')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§a<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_ladybug')) {
        if (sender.hasTag('is_transformed_bee')) return
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§4<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_fox')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§6<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_turtle')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§2<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_peacock')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§9<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_butterfly')) {
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§d<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
    if (sender.hasTag('is_transformed_bee')) {
        if (sender.hasTag('is_transformed_ladybug')) return
        if (message == "-preference ladybug ladybug" || message == "-preference ladybug misterbug") return
        sender.runCommand(`tellraw @a {\"rawtext\":[{\"text\":\"§g<\"},{\"selector\":\"@s\"},{\"text\":\">§r ${message}\"}]}`)
        evd.cancel = true
    }
})
World.events.beforeItemUse.subscribe(({ item,source }) => {
    const player = source
    if (item.id !== "miraculous:amok") return
    let actionForm = new ActionFormData()
    
    actionForm.title("title.choose_sentimonster")
    actionForm.body("description.choose_sentimonster")
    actionForm.button("button.candy_sentimonster")
    actionForm.button("button.coming_soon")
    actionForm.button("button.coming_soon")
    actionForm.button("button.coming_soon")
    actionForm.show(player).then( actionFormResponse => {
        const { selection } = actionFormResponse
        if (selection == 0) {
            player.runCommand("tellraw @a {\"rawtext\":[{\"text\":\"§9<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:fly_away_amok.speak\"}]}")
            player.runCommand("event entity @s miraculous:peacock_miraculous_summon_candy_sentimonster")
            player.runCommand("clear @s miraculous:amok 0 1")
        }
    })
})
